<?php

/**
 * @file
 */

namespace Drupal\smsc\Smsc;


use Smsc\Request\RequestInterface;
use Smsc\Services\AbstractSmscService;


/**
 * Class CurlMessage
 *
 * @package Smsc\CurlMessage
 */
class DrupalSmscRequest implements RequestInterface {

  /**
   * Execute request.
   *
   * @param AbstractSmscService $service
   *
   * @return string
   * @throws \Exception
   */
  public function execute(AbstractSmscService $service) {

    $uri  = $service->getApiUrl();
    $body = $service->buildParams();

    try {
      $response = drupal_http_request($uri, [
        'headers' => ['Content-Type' => 'application/x-www-form-urlencoded'],
        'method'  => 'POST',
        'data'    => $body,
      ]);

      return (string) $response->data;
    }
    catch (\Exception $e) {
      watchdog('smsc', $e, [], WATCHDOG_ERROR);
    }
  }
}
